# Tasks

## TODO Add test case for verbose mode in `tests/cli-opts.sh` {#task-910febe5-1718-4158-9406-f318081b281c}
- TODO in 2021-06-29

## TODO What about thread safety? {#task-008ac2d5-8de7-a125-962d-988780196d92}
- TODO in 2021-06-28

## TODO Add `ENVIRONMENT` section to the manpage {#task-97c113d0-b401-0c82-4119-39ce514717da}
- TODO in 2021-06-21

## DOING Test structure 2.0 {#task-e8a9be7f-5a41-fa14-0a11-7ac3bee98b7f}
- DOING in 2021-06-25
- TODO in 2021-06-21

---

1. delete `tests/alloc/` and `tests/string`: they focus too much on individual types of error (in this case `ENOMEM`) and they're too noisy (that's in part because of `fallible-check` itself);
2. rewrite `tests/fallible-check.sh`.

## TODO Handle integer wrapping {#task-d0126b02-ecf3-9d52-bda4-e1baf6a45781}
- TODO in 2021-06-20

---

Very relevant references:
- <https://wiki.sei.cmu.edu/confluence/pages/viewpage.action?pageId=87151979>
- <https://wiki.sei.cmu.edu/confluence/pages/viewpage.action?pageId=87152052>

## TODO Should it be `n < NL_TEXTMAX` or `n <= NL_TEXTMAX`? {#task-bb53a098-ee69-cf7e-fb69-fc0694d63607}
- TODO in 2021-06-20

## TODO Is it just glibc or is `NL_TEXTMAX` and `NL_MSGMAX` being undefined common? {#task-665a5f84-d0f6-0e88-ea05-2b60431c0d07}
- TODO in 2021-06-20

## TODO Fix "listede diffusion" formatting of pandoc at the bottom of manpages {#task-cf6f0118-4ca4-c95b-d4c9-e1b1b726fa78}
- TODO in 2021-06-20

## TODO Make libs drop-in replacements {#task-1bd7a128-7d33-08c4-ead5-254b88223c7f}
- TODO in 2021-06-19

---

That includes covering the full API of the original header.

Started at [`bc18e2244a803a7bcaef7069253c944800e3eb37`](https://git.euandreh.xyz/fallible/commit/?id=bc18e2244a803a7bcaef7069253c944800e3eb37).

The current more important ones for me are:

- <input type="checkbox" disabled /> `stdlib.h`
- <input type="checkbox" disabled /> `stdio.h`
- <input type="checkbox" disabled /> `string.h`

After the full implementation of each library, add it the list of available libraries in the `README.md` and on the manpages, and make a release.

## TODO Test the default name `"fallible-default"` {#task-820085e5-3196-3c83-7649-84d80cdf9efe}
- TODO in 2021-06-17

## DONE Replace `install` with `mkdir`, `chmod` and `cp` {#task-1362eae5-cb8f-0d4d-e55d-a3d265b5f720}
- DONE in 2021-06-19

  Done in
  [`cf26b9f21f650e69db6ce33943b43d0343206287`](https://git.euandreh.xyz/fallible/commit/?id=cf26b9f21f650e69db6ce33943b43d0343206287).
- TODO in 2021-06-17

## TODO Add -hV flags to fallible-check {#task-06ba5fce-cb3a-b281-709c-eba08095ed32}
- TODO in 2021-06-17

## TODO I don't think Valgrind can check for a `FILE *f` that wasn't `fclose`d.  How to do this? {#task-bf2361cd-d13a-9185-ae22-b45f0eb00fe9}
- TODO in 2021-06-16

## DONE Create static and shared libraries in a non-GCC-specific way {#task-525521c3-bbb1-53de-da35-fe703159467e}
- DONE in 2021-06-19

  The was simple: not building shared libraries, as there isn't a standard way to build them as of today (without pulling in big things such as libtool, which also isn't a standard, just something that tries its best).

  We now only build and distribute the static library.

  Done in
  [`cf26b9f21f650e69db6ce33943b43d0343206287`](https://git.euandreh.xyz/fallible/commit/?id=cf26b9f21f650e69db6ce33943b43d0343206287).
- TODO in 2021-06-16

---

Links:
- <https://stackoverflow.com/questions/7553184/how-to-do-versioning-of-a-shared-library-in-linux>
- <https://www.opengroup.org/onlinepubs/9699919799/utilities/c99.html>

## CANCELLED Test doxy2man {#task-a0cbecbd-6474-457b-83e9-08822c912bbd}
- CANCELLED in 2021-06-19

  Too much of a hassle for too little benefit.
  Hand-crafted manpages will also be superiour in quality.
- TODO in 2021-06-16

---

Links:

- <https://www.mankier.com/8/doxy2man>
- <https://stackoverflow.com/questions/16205329/how-to-get-man-page-output-for-the-main-page>

## TODO Translate manpages {#task-c21b5c6a-740c-6c4f-d9b4-12747c5d9ece}
- TODO in 2021-06-16

---

Also translate error messages from `fallible-check`.

The only manpages that actually need translating are `fallible-check.1` and `fallible_should_fail.3`.
The rest of them should even be deleted, as I now am thinking they're supposed to be drop-in replacements from who they refer to.

## DONE Move scripts/fallible-check to src/ {#task-b34b3d8c-241f-b328-8328-f36a658d2777}
- DONE in 2021-06-15

  Done in
  [`0c76fe310b46183efa4e0fac658eb4175cd5127a`](https://git.euandreh.xyz/fallible/commit/?id=0c76fe310b46183efa4e0fac658eb4175cd5127a).
- TODO in 2021-06-15

## TODO Test `fallible_should_fail.3` with fallible itself {#task-5619784c-7c22-40ae-235c-4227d5534b3e}
- TODO in 2021-06-15

## TODO Add tests for code in `14009e9d7610aeec4f9a28940b17eef01e9603d6` {#task-7b98708f-a163-f3ba-c9eb-3216c82c283f}
- TODO in 2021-06-14

---

[`14009e9d7610aeec4f9a28940b17eef01e9603d6`](https://git.euandreh.xyz/fallible/commit/?id=14009e9d7610aeec4f9a28940b17eef01e9603d6).

## TODO Add note on failures inside fallible itself: the library quits (!!) over propagating the error {#task-fa3e18eb-8a36-edce-8468-3a22a0d33178}
- TODO in 2021-06-14

---

Is there a more reasonable way to do this?
I can't see how propagating an error is useful, since fallible is a fault injection library.
If it encounters a failure while running itself, the caller has to disambiguate between injected system failures and failures that occured during the running of fallible itself.

It does seem reasonble to quit when finding an error.
I should look at the best option, bet it `exit.3`, `abort.3`, etc.

## TODO Add the types of errors as arguments to `fallible_should_fail` {#task-749cec52-6b48-0d4e-526a-684430ad108a}
- TODO in 2021-06-11

---

Maybe something like:

```c
bool fallible_should_fail(const char *const filename, int lineno, int[] errnos);

if (fallible_should_fail(__FILE__, __LINE__, {ENOMEM, EOVERFLOW}) { ... }
```

And change the implementation of `fallible_should_fail` accordingly.
This way a fallible function can fail more than once with different types of errors, according to its specification.

## CANCELLED Provide a `fallible.pc` pkg-config file {#task-22856a3b-8dcc-4484-809d-43b73335e378}
- CANCELLED in 2021-06-19

  Not necessary, as we're only building and installing the static artifact, but also we're relying exclusively on canonical directories.
- TODO in 2021-02-22

---

To allow for `--static` be used up in the dependency tree.

## TODO What other fault injection tools are there? {#task-405cd563-a46e-4dc0-93d9-8700fb70f035}
- TODO in 2021-02-19

---

Links to check and learn what they are about:
- <https://github.com/microsoft/checkedc>, <https://news.ycombinator.com/item?id=26190403>
- <https://scan.coverity.com/projects/curl>
- <https://en.wikipedia.org/wiki/AddressSanitizer>
- <https://google.github.io/oss-fuzz/>
- AFL?

This lead me to remove `unsafe.c` in
[`9b97d46dbb54468fee0d6db5a77a3396320220e0`](https://git.euandreh.xyz/fallible/commit/?id=9b97d46dbb54468fee0d6db5a77a3396320220e0).

Since Valgrind isn't really tracking a `NULL` pointer, this test would fail
depending on how the compiler did handle `strcpy(NULL, "")`.

## TODO Add hyperlinking to manpages _à la_ online manpages {#task-a147816c-2b1d-44e2-852b-d9a68487b559}
- TODO in 2021-02-16

---

See: <https://man7.org/linux/man-pages/man7/man-pages.7.html>

## DONE Improve documentation {#task-0905bf1c-34be-4f91-a20b-c22ee3d2b420}
- DONE in 2021-02-16
- TODO in 2021-02-16

## DONE Better and clearer testing structure {#task-4a4632e2-acff-43f5-8628-7c5e4f55cf4c}
- DONE in 2021-03-05
- TODO in 2021-02-14

---

Tests should cover:
- [x] environment variable

## TODO Add anchor to h1 headers generated from markdown.sh {#task-c747260f-9687-4c21-973d-c7a2c49479cb}
- TODO in 2021-02-08

## DONE Write manpages {#task-ac00bb45-c0f9-4417-91db-66e74d02b74e}
- DONE in 2021-02-25
- TODO in 2021-02-08

## TODO Double check that the file needs to be touched before being written to {#task-afb08120-306b-4545-bbb1-4c481b261ed8}
- TODO in 2021-02-04

---

```c
FILE *t = fopen(db_name, "a");
fclose(t);
if (!t) {
  fprintf(stderr, "Failed to touch '%s', exitting with error code 1.\n", db_name);
  exit(1);
}
```


# Bugs


# Improvements


# Questions

## TODO Use more `const` in the implementation? {#question-3f8d0168-379d-a74e-0c12-3eda4f128329}
- TODO in 2021-06-15

## TODO Use `calloc` vs `malloc`? {#question-03e2009c-a552-1565-f331-626d5fd11f8f}
- TODO in 2021-06-15


# Resources


# Scratch
