#ifndef UNIT_TEST_H
#define UNIT_TEST_H

#include <assert.h>

#define COLOUR_RESET  "\033[0m"
#define COLOUR_RED    "\033[0;31m"
#define COLOUR_GREEN  "\033[0;32m"
#define COLOUR_YELLOW "\033[0;33m"

void testing(const char *const message) {
	fprintf(stderr, COLOUR_YELLOW "testing" COLOUR_RESET ": %s...", message);
}

void test_ok() {
	fprintf(stderr, " " COLOUR_GREEN "OK" COLOUR_RESET ".\n");
}

#define ASSERT_MSG "\n" COLOUR_RED "ERROR" COLOUR_RESET ": "
#define assertf(A, M, ...) if (!(A)) { fprintf(stderr, (ASSERT_MSG M "\n"), __VA_ARGS__); assert(A); }
#define asserte(A) if (!(A)) { fprintf(stderr, ASSERT_MSG "\n"); assert(A); }

#endif
